/*
 * Copyright (c) 2005-2008 Substance Kirill Grouchnikov. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 *  o Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer. 
 *     
 *  o Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution. 
 *     
 *  o Neither the name of Substance Kirill Grouchnikov nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission. 
 *     
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */
package org.jvnet.substance.utils.menu;

import java.util.HashMap;
import java.util.Map;

import javax.swing.*;

import org.jvnet.substance.utils.SubstanceTrait;

public class TraitMenuHandler {
	protected ButtonGroup traitGroup;

	protected Map<String, AbstractButton> traitButtons;

	protected AbstractButton traitDummyButton;

	public TraitMenuHandler() {
		this.traitGroup = new ButtonGroup();
		this.traitButtons = new HashMap<String, AbstractButton>();
		this.traitDummyButton = new JToggleButton();
		this.traitGroup.add(this.traitDummyButton);
	}

//	public void addTraitButton(SubstanceTrait trait, AbstractButton traitButton) {
//		this.traitGroup.add(traitButton);
//		this.traitButtons.put(trait.getDisplayName(), traitButton);
//	}
//
	public void addTraitButton(String traitDisplayName, AbstractButton traitButton) {
		this.traitGroup.add(traitButton);
		this.traitButtons.put(traitDisplayName, traitButton);
	}

	private void selectTraitButton(String traitDisplayName) {
		final AbstractButton toSelect = this.traitButtons
				.containsKey(traitDisplayName) ? this.traitButtons
				.get(traitDisplayName) : this.traitDummyButton;
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				toSelect.setSelected(true);
			}
		});
	}

	public void selectTraitButton(SubstanceTrait trait) {
		this.selectTraitButton(trait.getDisplayName());
	}
}
