package test.contrib;

import java.awt.Font;

import javax.swing.*;
import javax.swing.table.DefaultTableModel;

import org.jvnet.substance.skin.SubstanceNebulaLookAndFeel;

/**
 * 
 * @author Kevin A. Roll
 */
public class Bug341 {
	public static void main(String[] args) throws Exception {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {
					UIManager.setLookAndFeel(new SubstanceNebulaLookAndFeel());

					JTable table = new JTable(new DefaultTableModel(3, 3)) {
						@Override
						public void updateUI() {
							System.err.println("Updating UI");
							super.updateUI();
						}
					};
					table.setFont(new Font("Arial", Font.PLAIN, 20));

					JFrame frame = new JFrame();
					frame.add(new JScrollPane(table));
					frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
					frame.pack();
					frame.setVisible(true);
				} catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		});
	}
}
