package test.contrib;

import java.awt.event.ActionEvent;

import javax.swing.*;

import org.jvnet.substance.skin.SubstanceSaharaLookAndFeel;

public class Bug344 {

	private JInternalFrame intern;

	private JDesktopPane desktopPane;

	private Bug344() throws Exception {

		JFrame frame = new JFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		desktopPane = new JDesktopPane();
		frame.setContentPane(desktopPane);
		intern = new JInternalFrame("intern");
		createMenu(frame);
		intern.setVisible(true);
		intern.setClosable(true);
		intern.setSize(200, 200);

		desktopPane.add(intern);
		frame.setSize(500, 500);
		frame.setVisible(true);

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		// if you remove the line everything works fine
		UIManager.setLookAndFeel(new SubstanceSaharaLookAndFeel());
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {
					new Bug344();
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});

	}

	private void createMenu(JFrame aFrame) {
		JMenuBar mb = new JMenuBar();
		final JMenu menu = new JMenu("test");
		mb.add(menu);
		menu.add(new AbstractAction("show") {
			public void actionPerformed(ActionEvent aE) {
				intern.setVisible(true);
				desktopPane.add(intern);
			}
		});
		aFrame.setJMenuBar(mb);
	}
}