package test.contrib;

import java.awt.BorderLayout;
import java.awt.event.*;
import java.util.Vector;

import javax.swing.*;
import javax.swing.table.DefaultTableModel;

import org.jvnet.substance.SubstanceLookAndFeel;

public class JTableRollovers extends JFrame {

	private static final long serialVersionUID = 0L;

	private JTable table = null;
	private DefaultTableModel tableModel = null;
	private JScrollPane tableSP = null;

	private MouseListener handleMouseSelectionListener = null;
	private KeyListener handleKeySelectionListener = null;

	public JTableRollovers() {

		try {
			UIManager.setLookAndFeel(new SubstanceLookAndFeel());
		} catch (Exception x) {
			x.printStackTrace();
		}

		table = new JTable();
		tableModel = new DefaultTableModel();
		tableSP = new JScrollPane();

		setLayout(new BorderLayout());

		tableModel.addColumn("A");
		tableModel.addColumn("B");
		tableModel.addColumn("C");
		tableModel.addColumn("D");
		tableModel.addColumn("E");
		tableModel.addColumn("F");
		tableModel.addColumn("G");
		tableModel.addColumn("H");
		tableModel.addColumn("I");
		tableModel.addColumn("J");
		tableModel.addColumn("K");
		tableModel.addColumn("L");
		tableModel.addColumn("M");
		tableModel.addColumn("N");
		tableModel.addColumn("O");
		tableModel.addColumn("P");
		tableModel.addColumn("Q");
		tableModel.addColumn("R");
		tableModel.addColumn("S");
		tableModel.addColumn("T");
		tableModel.addColumn("U");
		tableModel.addColumn("V");
		tableModel.addColumn("W");
		tableModel.addColumn("X");
		tableModel.addColumn("Y");
		tableModel.addColumn("Z");
		tableModel.addColumn("1");
		tableModel.addColumn("2");
		tableModel.addColumn("3");
		tableModel.addColumn("4");
		tableModel.addColumn("5");
		tableModel.addColumn("6");
		tableModel.addColumn("7");
		tableModel.addColumn("8");
		tableModel.addColumn("9");
		tableModel.addColumn("10");

		table.setModel(tableModel);

		tableSP.getViewport().add(table);

		// TableColumn tc;
		// for(int x=0; x<36; x++) {
		// tc.setCellRenderer( new TextFieldRenderer() );
		// }

		Vector rows = new Vector();
		for (int x = 0; x < 50; x++) {
			Vector row = new Vector();
			for (int z = 0; z < 36; z++) {
				row.add(x);
			}
			rows.add(row);
		}

		tableModel.getDataVector().addAll(rows);
		table.setRowHeight(19);

		handleMouseSelectionListener = new MouseAdapter() {
			public void mouseReleased(MouseEvent event) {
				// When the user clicks a study in the study history table
				// Display the report for that study in the report panel
				// if one exists, otherwise clear the report panel and
				// specify that a report does not exist
				// handleStudyHistorySelection();
				try {
					Thread.sleep(200);
				} catch (Exception ee) {

				}
			}
		};
		handleKeySelectionListener = new KeyAdapter() {
			public void keyReleased(KeyEvent event) {
				// When the user clicks a study in the study history table
				// Display the report for that study in the report panel
				// if one exists, otherwise clear the report panel and
				// specify that a report does not exist

				// Only run during up/down or left/right arrows
				int keycode = event.getKeyCode();
				// if( keycode == KeyEvent.VK_DOWN || keycode == KeyEvent.VK_UP
				// ||
				// keycode == KeyEvent.VK_LEFT || keycode == KeyEvent.VK_RIGHT )
				// {
				// Dont allow the control key to invoke the history selection
				// because the user may be using control key while selecting
				// more than one history item, the selection will run on control
				// mouseRelease, but when he lets go of the control key we dont
				// want this to run again
				if (keycode != KeyEvent.VK_CONTROL) {
					// handleStudyHistorySelection();
				}
				// }
				try {
					Thread.sleep(200);
				} catch (Exception ee) {

				}
			}
		};

		table.addKeyListener(handleKeySelectionListener);
		table.addMouseListener(handleMouseSelectionListener);

		this.add(tableSP, BorderLayout.CENTER);

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		JTableRollovers jtableTest = new JTableRollovers();
		jtableTest.setTitle("Reproduce JTable Rollover Issue");
		jtableTest.setSize(700, 500);
		jtableTest.setVisible(true);
		jtableTest.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

}
