package test.contrib;

import java.awt.Color;

import javax.swing.*;
import javax.swing.plaf.ColorUIResource;

import org.jvnet.substance.SubstanceLookAndFeel;

public class TooltipBackColor extends JFrame {
	public TooltipBackColor() {
		JTextField firstSectionLength_TextField = new JTextField() {
			public JToolTip createToolTip() {
				JToolTip tip = super.createToolTip();
				tip.updateUI();
				tip.setBackground(Color.YELLOW);
				tip.setForeground(Color.RED);
				return tip;
			}
		};
		firstSectionLength_TextField.setToolTipText("First Section Length");
		UIManager.put("ToolTip.background", new ColorUIResource(Color.yellow));
		
		firstSectionLength_TextField.setText("myText");
		
		this.add(firstSectionLength_TextField);
		this.pack();
		this.setLocationRelativeTo(null);
		
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	
	public static void main(String[] args) throws Exception {
		UIManager.setLookAndFeel(new SubstanceLookAndFeel());
		new TooltipBackColor().setVisible(true);
	}

}
